<? if ( !defined("_INCLUDED_GLOBAL") ) die("Access Denied");		// [Security]Allow_url_fopen = On ?>
<?


// [2008-02-19] 대용량첨부 다운횟수/기간 초과처리
function bigfile_expire($bigfile, $is_expire=true, $upload_dir='')
{
	global $TB, $G_SYS, $UPLOAD_ROOT, $UPLOAD_ROOT_NEW;

	if ($bigfile['bf_expire'] != 'Y')
	{
		if ($upload_dir == '')
		{
			$q = "SELECT m_id, m_mail_file_group, d_no FROM ".$TB['MEMBER']." WHERE m_no='".$bigfile['m_no']."'";
			$mbr = db_get_row($q);
			$upload_dir = 'bigfile/'.get_d_name($mbr['d_no']).'/'.$mbr['m_mail_file_group'].'/'.$mbr['m_id'];
		}	// if()
		$UPLOAD_ROOT_ORI = $UPLOAD_ROOT;
		$UPLOAD_ROOT = $UPLOAD_ROOT_NEW;
		if (!$is_expire)
		{
			// 만료여부 검사
			$limit_date = date('Y-m-d', (strtotime($bigfile['bf_regdate'])+(86400*($G_SYS[UPLOAD_MAIL_BIGFILE_DAY]-1))));
			if ($bigfile['bf_down'] >= $G_SYS[UPLOAD_MAIL_BIGFILE_COUNT] || date('Y-m-d') > $limit_date)
			{
				$is_expire = true;
			} else if ($bigfile['bf_expire'] == 'Y')
			{
				$is_expire = true;
			} else if (!file_exists($UPLOAD_ROOT.'/'.$upload_dir.'/'.$bigfile['bf_key']))		// [2014-05-28] 파일이 존재하지 않을 경우, 만료로 처리.
			{
				$is_expire = true;
			} else
			{
				return false;
			}	// if()
		}	// if()

		$sql = "
			UPDATE
				".$TB['BIGFILE']."
			SET
				bf_expire='Y'
			WHERE
				bf_key='" . $bigfile['bf_key'] . "'
				AND m_no='" . $bigfile['m_no'] . "'
			";
		db_query($sql);

		if ($bigfile['bf_type'] == 'B')
		{
			// file del - 대용량 첨부, 다운로드 횟수/기간이 초과하여 파일이 삭제된 경우를 고려하여 파일이 존재할때만 삭제함.
				if (file_exists($UPLOAD_ROOT.'/'.$upload_dir.'/'.$bigfile['bf_key']))
				{
					require_once("include/file.php");
					$errorMsg = file_del($bigfile['bf_key'], '', $upload_dir);
					if ($errorMsg)
						errorlog("대용량 첨부 파일 삭제가 실패하였습니다.\n=> " . $UPLOAD_ROOT . '/' . $upload_dir . '/' . $bigfile['bf_key'] . $errorMsg, 'FILE');

					require_once('include/member_size_lib.php');
					member_size_update($bigfile['m_no'], 'BIGFILE', -($bigfile['bf_size']));
				}	// if()
		}	// if()

		$UPLOAD_ROOT = $UPLOAD_ROOT_ORI;
	} else
	{
		$is_expire = true;
	}	// if()

	return $is_expire;
}	// function()


// [2008-02-19] 임시 업로드 디렉토리에서 3시간이 지난 파일은 자동 삭제.
// bigfile_upload_tmp_del($UPLOAD_DIR[BIGFILE_TMP]);
function bigfile_upload_tmp_del($upload_dir)
{
	global $G_SYS, $UPLOAD_ROOT, $UPLOAD_ROOT_NEW;

	$G_SYS['BIGFILE_UPLOAD_TMP_DEL_HOUR'];

	$UPLOAD_ROOT_ORI = $UPLOAD_ROOT;
	$UPLOAD_ROOT = $UPLOAD_ROOT_NEW;

	$tmpdir = $UPLOAD_ROOT_NEW.'/'.$upload_dir;

	// 삭제 기준 시간
	if ($G_SYS['BIGFILE_UPLOAD_TMP_DEL_HOUR'])
		$G_SYS['BIGFILE_UPLOAD_TMP_DEL_HOUR'] = 3;

	$del_time = (time() - ($G_SYS['BIGFILE_UPLOAD_TMP_DEL_HOUR']*3600));

	if (is_dir($tmpdir))
	{
		// [2008-06-04] 편지함 복구시 임시 디렉토리 삭제
		if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN')
		{
			$cmd_rm = 'rmdir/q/s';
		} else
		{
			$cmd_rm = 'rm -rf';
		}	// if()

		// [2009-06-09] 임시 디렉토리 삭제시 오류 해결
		require_once("include/file.php");

		$files = array();
		if ($dh = opendir($tmpdir)) {
			while (($file = readdir($dh)) !== false) {
				if ($file!="." && $file!=".." && is_file($tmpdir.'/'.$file) && filemtime($tmpdir.'/'.$file) <= $del_time)
				{
					$errorMsg = file_del($file, "", $upload_dir);
					if ($errorMsg)
						errorlog("임시 업로드 파일 삭제가 실패하였습니다.\n=> " . $tmpdir. '/' . $file . $errorMsg, 'FILE');
				} else if (strpos($file, 'NmailRestore_') !== false && is_dir($tmpdir.'/'.$file) && filemtime($tmpdir.'/'.$file) <= $del_time)
				{
					// [2008-06-04] 편지함 복구시 임시 디렉토리 삭제
					if ($tmpdir != '' && strpos($file, 'NmailRestore_') !== false)		// 프로그램상의 미스로 인하여 / 파티션이 삭제되는 것 예방.
						system($cmd_rm.' '.escapeshellarg(realpath($tmpdir.'/'.$file.'/')));
				}	// if()
			}
			closedir($dh);
		} else
		{
			errorlog("임시 업로드 디렉토리의 퍼미션이 잘못되어 자동 삭제가 실패하였습니다.\n=> " . $tmpdir, 'FILE');
		}	// if()
	}	// if()

	$UPLOAD_ROOT = $UPLOAD_ROOT_ORI;
}	// function()


?>