<?
require_once('include/global.php');
require_once("include/webhard_lib.php");
require_once("include/bigfile_lib.php");
require_once("include/file.php");
#require_once('./conf.inc.php');


$msg = "대용량 첨부파일을 다운로드 받을 수 없습니다.\\n\\n보낸사람에 의해 삭제되었거나 잘못된 주소입니다.";


if (!$_GET['id'])
	msg('대용량 첨부파일 다운로드 주소가 잘못 되었습니다.');

$bf = bigfile_id_decode($_GET['id']);

if (sizeof($bf) != 4 || !is_numeric($bf[0]))
	msg('대용량 첨부파일 다운로드 주소가 잘못 되었습니다.');


// data
	$DEBUG['db_select']['start'] = getmicrotime();

	// db - select
		$sql = "
			SELECT
				*
			FROM
				".$TB['BIGFILE']."
			WHERE
				bf_key='" . $bf[0] . "'
			";
		$bigfile = db_get_row($sql);


	// check
		if (!$bigfile || $bf[3] != $bigfile['bf_regdate'])
			msg($msg.'[1]');

		$limit_date = date('Y-m-d', (strtotime($bigfile['bf_regdate'])+(86400*($G_SYS[UPLOAD_MAIL_BIGFILE_DAY]-1))));

		if (date('Y-m-d') > $limit_date)
		{
			bigfile_expire($bigfile);
			msg("대용량 첨부파일을 다운로드 받을 수 없습니다.\\n\\n다운로드 가능기간이 지났습니다.");
		}	// if()
	
		if ($bigfile['bf_down'] >= $G_SYS[UPLOAD_MAIL_BIGFILE_COUNT])
		{
			bigfile_expire($bigfile);
			msg("대용량 첨부파일을 다운로드 받을 수 없습니다.\\n\\n다운로드 가능횟수가 초과되었습니다.");
		}	// if()
		
		// [2014-05-28] 서버에서 파일이 삭제되었거나, 대용량 첨부 아카이빙에서 차단된 경우.
		if ($bigfile['bf_expire'] == 'Y')
		{
			msg("대용량 첨부파일을 다운로드 받을 수 없습니다.\\n\\n다운로드가 차단되었습니다.");
		}	// if()
		

	// get
		if ($bigfile['bf_type'] == 'W')		// 웹하드
		{
			$q = "SELECT COUNT(*) FROM ".$TB['WEBHARD_FILE']." WHERE wf_key='".$bigfile['wf_key']."'";
			$wf = db_get_one($q);
			if ($wf < 1)
				msg($msg.'[2]');

			$q = "SELECT ws_key, m_no FROM ".$TB['WEBHARD_FOLDER']." WHERE wfd_key='".$bigfile['wfd_key']."'";
			$wfd = db_get_row($q);
			if (!$wfd)
				msg($msg.'[3]');

			if ($wfd['ws_key'] > 0)		// 공용웹하드
			{
				$upload_dir = 'webhard/'.$G_SYS[MAIL_DOMAIN].'/share/'.$wfd['ws_key'];
			} else		// 개인웹하드
			{
				$q = "SELECT m_id, m_mail_file_group FROM ".$TB['MEMBER']." WHERE m_no='".$wfd['m_no']."'";
				$mbr = db_get_row($q);
				$upload_dir = 'webhard/'.$G_SYS[MAIL_DOMAIN].'/'.$mbr['m_mail_file_group'].'/'.$mbr['m_id'];
			}	// if()
			$file_name_save = $bigfile['wf_key'];

		} else		// 대용량 첨부
		{
			$q = "SELECT m_id, m_mail_file_group FROM ".$TB['MEMBER']." WHERE m_no='".$bigfile['m_no']."'";
			$mbr = db_get_row($q);
			$upload_dir = 'bigfile/'.$G_SYS[MAIL_DOMAIN].'/'.$mbr['m_mail_file_group'].'/'.$mbr['m_id'];
			$file_name_save = $bigfile['bf_key'];
		}	// if()


	// 다운로드 횟수 증가
		$sql = "
			UPDATE
				".$TB['BIGFILE']."
			SET
				bf_down = bf_down + 1
			WHERE
				bf_key='" . $bf[0] . "'
			";
		db_query($sql);


	// db disconnect
		unset_db();

	$DEBUG['db_select']['exec'] += getmicrotime() - $DEBUG['db_select']['start'];


// download
		$UPLOAD_ROOT = $UPLOAD_ROOT_NEW;

		$errorMsg = file_down($file_name_save, NULL, $upload_dir, NULL, $bigfile['bf_name']);
		if ($errorMsg)
		{
			errorlog("파일 다운로드가 실패하였습니다.\n=> " . $UPLOAD_ROOT . '/' . $upload_dir . '/' . $file_name_save . $errorMsg, 'FILE');
			msg($msg.'[4]');
		}		// if()

// 다운로드를 위해 디버깅정보 생략.
//require_once('include/global_end.php');
?>